part of web_api;
/// A metadata annotation, which adds media links to the result of a [ApiMethod]
abstract class HypermediaLinkProvider<T>{


  void apply(Map json, T controller, HttpRequest request,[int index]){
    List<HypermediaLink> links = createLinks(controller,index);
    links.forEach((l)=>l.uri=request.requestedUri.origin+l.uri);
    json["links"]=links;
  }

  /// Creates a list of links, which should be added to the result of the method
  List<HypermediaLink> createLinks(T controller,[int index]);

  const HypermediaLinkProvider();

}
