library web_api;

import 'dart:mirrors';
import 'dart:io';
import 'dart:convert';
import 'dart:async';
import 'package:serializer/serializer.dart';
import 'package:func/func.dart';

part 'src/request_mapper.dart';
part 'src/request_mapping.dart';
part 'src/parameter_resolver.dart';
part 'src/response_builder.dart';
part 'src/controller.dart';

part 'src/metadata/body.dart';
part 'src/metadata/api_method.dart';
part 'src/metadata/http_get.dart';
part 'src/metadata/http_post.dart';
part 'src/metadata/http_put.dart';
part 'src/metadata/http_delete.dart';
part 'src/metadata/handles_response.dart';
part 'src/metadata/query.dart';

part 'src/exceptions/controller_exception.dart';

part 'src/hateoas/hypermedia_link.dart';
part 'src/hateoas/hypermedia_link_provider.dart';
part 'src/hateoas/link_appender.dart';